function bco00600_comparativo_previsto_realizado_Controller(General, ScreenService, templateManager, ZhFilterPreferences, localStorageEngine) {

    var self = this;

    this.openFilter = function(widget){
        General.callRestEngine( "fin#/paramgeral_geralrec", 'FilterData', []).then(function (paramgeral) {
            var rowsToSet = {};
            paramgeral = paramgeral.dataset.paramgeral_geralrec[0] || [];
            if(paramgeral.IDTPORCAFINA == 'F'){
                widget.getField('CDFILIAL').isVisible = true;
                
                
                if(widget.getField('CDFILIAL').validations){
                    widget.getField('CDFILIAL').validations = {};
                    widget.getField('CDFILIAL').validations.required = true;
                }
                rowsToSet.CDFILIAL = null;
            }else{
                widget.getField('CDFILIAL').isVisible = false;
                rowsToSet.CDFILIAL = getLocalVar('CDFILIAL');
                
                if(widget.getField('CDFILIAL').validations){
                    delete widget.getField('CDFILIAL').validations.required;    
                }
            }
            rowsToSet.TPORCAFINA = paramgeral.IDTPORCAFINA;

            ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
            
        });
        

    };

    this.changeHeaderValues = function(widget, data){
        var newFilter = widget.e.metadata.filter;
        
        newFilter.push({"label": 'Período', "value": widget.owner.dataSourceFilter[0].value + ' a ' + widget.owner.dataSourceFilter[1].value });

    };
    
    this.preparaFiltroMovimentacao = function(args) {
        var widget    = templateManager.container.getWidget('comparativo_grid');
    	var filterRow = args.e.preference.FILTER_ROW;
    	var itemErradoIndex = null;
    	
    	for(var index = 0, filters = widget.dataSourceFilter; index< filters.length ; index ++){
    	   var item = filters[index];
            if(item.name == 'DTINI'){
    	        item.value = filterRow.DTMES ? filterRow.DTMES.start : null;
    	    }else if(item.name == 'DTFIM'){
    	        item.value = filterRow.DTMES ? filterRow.DTMES.end : null;
    	    }else if(item.name == 'CDEMPRESA'){
    	        item.value = item.value?(item.value.length > 0 && Array.isArray(item.value)?item.value.join('_'):'T'):'T';
    	    }else if(!filterRow[item.name]){
    	        item.value = 'T';
    	    }else if(filterRow[item.name] && (!item.value|| Array.isArray(item.value))){
    	        item.value = filterRow[item.name];
    	    }
    	    if(item.name == 'DTMES' || item.name == 'NMEMPRESA'){
    	        itemErradoIndex = index;
    	        break;
    	    }
    	}
        if(itemErradoIndex != null){
            widget.dataSourceFilter.splice(itemErradoIndex, 1);
            self.preparaFiltroMovimentacao(args);    
        }else{
            widget.reload();    
        }
    	
    };

    self.onChangeEmpresaFilter = function(widget){
        var cdempresa = widget.currentRow.CDEMPRESA;
        var FILIAL = widget.getField('CDFILIAL');
        if(FILIAL.isVisible){
            FILIAL.setValue("");
            if(cdempresa.length){  
                FILIAL.dataSourceFilter[0].value = cdempresa;
                FILIAL.readOnly = false;
                FILIAL.reload();    
            }else{
                FILIAL.readOnly = true;
            }    
        }
    };
}

Configuration(function (ContextRegister) {
	ContextRegister.register('bco00600_comparativo_previsto_realizado_Controller', bco00600_comparativo_previsto_realizado_Controller);
});